//---------------------------------------------------------------------------


#pragma hdrstop

#include <json/json.h>
#include <fstream> 
#include "Settings.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

bool Settings::Read(AnsiString asFileName)
{
	chap.asChallengePrompt = "prompt";
	chap.iChallengeLength = 32;
	chap.asPwd1 = "pwd 1";
	chap.asPwd2 = "pwd 2";

	Json::Value root;   // will contains the root value after parsing.
	Json::Reader reader;

	std::ifstream ifs(asFileName.c_str());
	std::string strConfig((std::istreambuf_iterator<char>(ifs)), std::istreambuf_iterator<char>());
	ifs.close();

	bool parsingSuccessful = reader.parse( strConfig, root );
	if ( !parsingSuccessful )
		return true;

	chap.asChallengePrompt = root.get("ChallengePrompt", "prompt").asString().c_str();
	chap.asPwd1 = root.get("Pwd1", "pwd 1").asString().c_str();
	chap.asPwd2 = root.get("Pwd2", "pwd 2").asString().c_str();
	chap.iChallengeLength = root.get("ChallengeLength", 32).asInt();

	return true;
}

bool Settings::Write(AnsiString asFileName)
{
    Json::Value root;
	Json::StyledWriter writer;
	root["ChallengePrompt"] = chap.asChallengePrompt.c_str();
	root["Pwd1"] = chap.asPwd1.c_str();
	root["Pwd2"] = chap.asPwd2.c_str();
	root["ChallengeLength"] = chap.iChallengeLength;

	std::string outputConfig = writer.write( root );

	std::ofstream ofs(asFileName.c_str());
	ofs << outputConfig;
	ofs.close();
	return true;

}
