//---------------------------------------------------------------------------


#pragma hdrstop

#include "chap.h"
#define _EXPORTING
#include "..\OTerm\plugin\PluginInterface.h"
#include "FormSettings.h"
#include "Utils.h"
#include "md5.h"
#include "bin2str.h"
#include <stdio.h>

//---------------------------------------------------------------------------

#pragma package(smart_init)

Settings appSettings;

static const struct S_DLL_INTERFACE dll_interface =
	{DLL_INTERFACE_MAJOR_VERSION, DLL_INTERFACE_MINOR_VERSION};

// callback ptrs
CALLBACK_SEND lpSendFn = NULL;

void *callbackCookie;	///< used by upper class to distinguish library instances when receiving callbacks

namespace
{
	bool armed = true;
	int promptMatched = 0;
	AnsiString asChallenge;
}

void __stdcall GetInterfaceDescription(struct S_DLL_INTERFACE* interf)
{
	interf->majorVersion = dll_interface.majorVersion;
	interf->minorVersion = dll_interface.minorVersion;
}

void __stdcall SetCallbacks(void *cookie, CALLBACK_SEND lpSend)
{
	lpSendFn = lpSend;
	callbackCookie = cookie;
}

void __stdcall ShowSettings(HANDLE parent)
{
	frmSettings = new TfrmSettings(NULL);
	frmSettings->appSettings = &appSettings;
	frmSettings->ShowModal();
	delete frmSettings;
	appSettings.Write(Utils::ReplaceFileExtension(Utils::GetDllPath(), ".json").c_str());
}

void __stdcall ChangeConnectionState(int state)
{
	if (state == OTERM_CONNECTED)
	{
		promptMatched = 0;		
		armed = true;
		asChallenge = "";
	}
}

static std::string md5string(std::string in)
{
    unsigned char digest[16];
    char returnVal[64] = {0};
    char tmp[16];
    pj_md5_context mdContext;
    pj_md5_init(&mdContext);
    pj_md5_update(&mdContext, (unsigned char*)in.data(), in.size());
    pj_md5_final (&mdContext, digest);
    for (int i = 0; i < 16; i++)
    {
        sprintf (tmp, "%02x", digest[i]);
        strcat(returnVal, tmp);
    }
    return (std::string)returnVal;
}

void __stdcall OnRx(void *buffer, unsigned int buffersize)
{
	if (armed == false)
		return;
	char *rx = (char*)buffer;
	while (buffersize > 0 && promptMatched < appSettings.chap.asChallengePrompt.Length())
	{
		if (*rx == appSettings.chap.asChallengePrompt[promptMatched+1])
			promptMatched++;
		else
			promptMatched = 0;
		rx++;
		buffersize--;
		if (promptMatched == appSettings.chap.asChallengePrompt.Length())
		{
			break;
		}
	}
	if (promptMatched == appSettings.chap.asChallengePrompt.Length())
	{
		while ((buffersize > 0) && asChallenge.Length() < appSettings.chap.iChallengeLength)
		{
			if ((*rx) != '\0')
				asChallenge = asChallenge + (*rx);
			rx++;
			buffersize--;	
		}
	}
	if (asChallenge.Length() == appSettings.chap.iChallengeLength)
	{
		armed = false;
		if (asChallenge.Length() != 32 || appSettings.chap.asPwd1.Length() != 32)
		{
			return;
		}
		char tmp[10], returnVal [64];
		unsigned char digest[16];
		int i;
		pj_md5_context mdContext;

		pj_md5_init(&mdContext);
		std::string in;
		in = HexStringToBuf(asChallenge.c_str());
		pj_md5_update(&mdContext, (unsigned char*)in.data(), in.size());
		if (appSettings.chap.asPwd1.Length())
		{
			in = HexStringToBuf(appSettings.chap.asPwd1.c_str());
			pj_md5_update(&mdContext, (unsigned char*)in.data(), in.size());
		}

		std::string userpwd = md5string(appSettings.chap.asPwd2.c_str());
		pj_md5_update(&mdContext, (unsigned char*)userpwd.c_str(), userpwd.size());

		pj_md5_final (&mdContext, digest);

		strcpy(returnVal, "");
		for (i = 0; i < 16; i++)
		{
			sprintf (tmp, "%02x", digest[i]);
			strcat(returnVal, tmp);
		}
		lpSendFn(callbackCookie, returnVal, strlen(returnVal));
    }
}

void __stdcall OnTx(void *buffer, unsigned int buffersize)
{

}
